<?php

namespace Teknisa\CNC\Services;

use Zeedhi\Framework\DTO\Response\Error;
use Teknisa\CNC\Utilities;
use Teknisa\CNC\Factories;

class Cnc00700RecebimentoBandeira {

	protected $entityManager;
	protected $util;
	protected $recebimentoBandeiraFactory;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager, Utilities\UtilCNC $util, Factories\Cnc00700RecebimentoBandeiraFactory $recebimentoBandeiraFactory)  {
		$this->entityManager = $entityManager;
		$this->util  = $util;
		$this->recebimentoBandeiraFactory  = $recebimentoBandeiraFactory;
	}

	public function getReceiptFlagsP($params){
	    $P_NRESTABELEC      = $params[0]['value'];
        $P_NRADQUIRENTE      = $params[1]['value'];
        $P_NRPRODUTOADQ  = $params[2]['value'];
        $P_NRBANDEIRAVAN     = $params[3]['value'];
        for ($i=0; $i < sizeof($params); $i++) {
            if($params[$i]["columnName"] === 'intervalo'){
                $P_INTVEND = str_replace('%', '', $params[$i]['value']);
            }
        }
        if($P_INTVEND === 'M'){
            for ($i=0; $i < sizeof($params); $i++) {
                if($params[$i]["columnName"] === 'MESINI'){
                    $P_MESINI = str_replace('%', '', $params[$i]['value']);
                } if($params[$i]["columnName"] === 'MESFIN'){
                    $P_MESFIN = str_replace('%', '', $params[$i]['value']);
                }
            }
            $P_TPVLR         = str_replace('%', '', $params[7]['value']);
            $MEIORECE        = str_replace('%', '', $params[8]['value']);
            $P_TNRESTABELEC     = null;
            $P_TNRADQUIRENTE     = null;
            $P_TNRPRODUTOADQ = null;
            $P_TNRBANDEIRAVAN    = null;
            $DTVENDAINI     = '01/'.$P_MESINI;
            $lastDay        = date("t",mktime(0,0,0,substr($P_MESFIN, 0, -5),1,substr($P_MESFIN, -4)));
            $DTVENDAFIN     = $lastDay.'/'.$P_MESFIN;
            $explodeini     =  explode('/', $DTVENDAINI);
            $explodefin     =  explode('/', $DTVENDAFIN);
            $P_DTVENDAINI   = $explodeini[1].'/'.$explodeini[0].'/'.$explodeini[2]; 
            $P_DTVENDAFIN   = $explodefin[1].'/'.$explodefin[0].'/'.$explodefin[2];
            $P_VRDTVENDAINI = date_format(date_create($P_DTVENDAINI), "Ym");
            $P_VRDTVENDAFIN = date_format(date_create($P_DTVENDAFIN), "Ym");
            if ($P_VRDTVENDAFIN < $P_VRDTVENDAINI){
                throw new \Exception('MESERROR',1);
            }
            if ($P_VRDTVENDAFIN - $P_VRDTVENDAINI > 99){
                throw new \Exception('MESEXCEDEU',2);
            }
        } else{
            for ($i=0; $i < sizeof($params); $i++) {
                if($params[$i]["columnName"] === 'DTVENDA'){
                    $DTVENDAINI = str_replace('%', '', $params[$i]['value'][0]);
                    $DTVENDAFIN = str_replace('%', '', $params[$i]['value'][1]);
                }
            }
            $P_TPVLR         = str_replace('%', '', $params[6]['value']);
            $MEIORECE        = str_replace('%', '', $params[7]['value']);
            $P_TNRESTABELEC     = null;
            $P_TNRADQUIRENTE     = null;
            $P_TNRPRODUTOADQ = null;
            $P_TNRBANDEIRAVAN    = null;

            $explodeini     =  explode('/', $DTVENDAINI);
            $explodefin     =  explode('/', $DTVENDAFIN);
            $P_DTVENDAINI   = $explodeini[2].'/'.$explodeini[1].'/'.$explodeini[0]; 
            $P_DTVENDAFIN   = $explodefin[2].'/'.$explodefin[1].'/'.$explodefin[0];
            $P_VRDTVENDAINI = date_create($P_DTVENDAINI);
            $P_VRDTVENDAFIN = date_create($P_DTVENDAFIN);
            $P_VRDTVENDA    = $P_VRDTVENDAFIN->diff($P_VRDTVENDAINI);
            if($P_VRDTVENDA->d > 14){
                throw new \Exception('DIAERROR',1);
            }
        }
        if($P_NRESTABELEC === 'Todas'){
            $P_TNRESTABELEC = 'T';
            $P_NRESTABELEC = null;
        }
        if($P_NRADQUIRENTE === 'Todas'){
            $P_TNRADQUIRENTE = 'T';
            $P_NRADQUIRENTE = null;
        }
        if($P_NRPRODUTOADQ === 'Todos'){
            $P_TNRPRODUTOADQ = 'T';
            $P_NRPRODUTOADQ = null;
        }
        if($P_NRBANDEIRAVAN === 'Todas'){
            $P_TNRBANDEIRAVAN = 'T';
            $P_NRBANDEIRAVAN = null;
        }
        if(is_array($P_NRESTABELEC) || is_array($P_NRADQUIRENTE) || is_array($P_NRPRODUTOADQ) || is_array($P_NRBANDEIRAVAN)){
            $query = "SELECT REPLACE(TO_CHAR(R.DTVENDA, 'MONTH-YYYY'), ' ', '') DATAVENDA, TO_NUMBER(TO_CHAR(R.DTVENDA, 'MMYYYY')) ORDEM, B.NMBANDEIRA, SUM(DECODE(:P_TPVLR, 'B', R.VRBRUTVENDA, R.VRLIQVENDA)) AS VRVENDA FROM RETVENDAADQ R, ADQUIRENTE A, PRODUTOADQ P, BANDEIRAVAN B, CONSMOVCAIXA C WHERE R.NRADQUIRENTE = A.NRADQUIRENTE AND R.NRPRODUTOADQ = P.NRPRODUTOADQ AND R.NRCONCLANC = C.NRCONCLANC AND R.NRBANDEIRAVAN = B.NRBANDEIRAVAN AND :P_INTVEND = 'M'AND R.DTVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN AND ((INSTR (:P_NRESTABELEC,     '|'||TO_CHAR(R.NRESTABELEC)||'|') > 0) OR ('T' = :P_TNRESTABELEC)) AND ((INSTR (:P_NRADQUIRENTE,     '|'||TO_CHAR(A.NRADQUIRENTE)||'|') > 0) OR ('T' = :P_TNRADQUIRENTE)) AND ((INSTR (:P_NRPRODUTOADQ, '|'||TO_CHAR(P.NRPRODUTOADQ)||'|') > 0) OR ('T' = :P_TNRPRODUTOADQ)) AND ((INSTR (:P_NRBANDEIRAVAN,    '|'||TO_CHAR(B.NRBANDEIRAVAN)||'|') > 0) OR ('T' = :P_TNRBANDEIRAVAN)) AND P.IDVISIVEL = 'S'AND B.IDVISIVEL = 'S'AND A.IDVISIVEL = 'S'GROUP BY REPLACE(TO_CHAR(R.DTVENDA, 'MONTH-YYYY'), ' ', ''), TO_NUMBER(TO_CHAR(R.DTVENDA, 'MMYYYY')), B.NMBANDEIRA UNION SELECT REPLACE(TO_CHAR(R.DTVENDA, 'DD/MM/YY'), ' ', '') DATAVENDA, TO_NUMBER(TO_CHAR(R.DTVENDA, 'MMYYYY')) ORDEM, B.NMBANDEIRA, SUM(DECODE(:P_TPVLR, 'B', R.VRBRUTVENDA, R.VRLIQVENDA)) AS VRVENDA FROM RETVENDAADQ R, ADQUIRENTE A, PRODUTOADQ P, BANDEIRAVAN B, CONSMOVCAIXA C WHERE R.NRADQUIRENTE = A.NRADQUIRENTE AND R.NRPRODUTOADQ = P.NRPRODUTOADQ AND R.NRCONCLANC = C.NRCONCLANC AND R.NRBANDEIRAVAN = B.NRBANDEIRAVAN AND :P_INTVEND = 'D'AND R.DTVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN AND ((INSTR (:P_NRESTABELEC,     '|'||TO_CHAR(R.NRESTABELEC)||'|') > 0) OR ('T' = :P_TNRESTABELEC)) AND ((INSTR (:P_NRADQUIRENTE,     '|'||TO_CHAR(A.NRADQUIRENTE)||'|') > 0) OR ('T' = :P_TNRADQUIRENTE)) AND ((INSTR (:P_NRPRODUTOADQ, '|'||TO_CHAR(P.NRPRODUTOADQ)||'|') > 0) OR ('T' = :P_TNRPRODUTOADQ)) AND ((INSTR (:P_NRBANDEIRAVAN,    '|'||TO_CHAR(B.NRBANDEIRAVAN)||'|') > 0) OR ('T' = :P_TNRBANDEIRAVAN)) AND P.IDVISIVEL = 'S'AND B.IDVISIVEL = 'S'AND A.IDVISIVEL = 'S'GROUP BY REPLACE(TO_CHAR(R.DTVENDA, 'DD/MM/YY'), ' ', ''), TO_NUMBER(TO_CHAR(R.DTVENDA, 'MMYYYY')), B.NMBANDEIRA ORDER BY 2,1,3"; 
            if(is_array($P_NRESTABELEC)){
                $paramsfilial = array(
                    ':P_NRESTABELEC' => $P_NRESTABELEC
                );
                foreach (array_keys($paramsfilial) as $index => $name) {
                    if(!empty($paramsfilial[$name])){
                        $query = $this->util->putArrayOnQuery($query, $name, $paramsfilial[$name]);
                        $paramsfilial[$name] = '';
                    }
                    else{
                        $paramsfilial[$name] = 'null';
                    }
                }
            } else {
                $paramsfilial = array(
                    ':P_NRESTABELEC' => 'null'
                );
                 $query = preg_replace('/'.':P_NRESTABELEC'.'/', $paramsfilial[':P_NRESTABELEC'], $query, 4);
            }
            if(is_array($P_NRADQUIRENTE)){
                $paramsadquirirente = array(
                    ':P_NRADQUIRENTE' => $P_NRADQUIRENTE
                );
                foreach (array_keys($paramsadquirirente) as $index => $name) {
                    if(!empty($paramsadquirirente[$name])){
                        $query = $this->util->putArrayOnQuery($query, $name, $paramsadquirirente[$name]);
                        $paramsadquirirente[$name] = '';
                    }
                    else{
                        $paramsadquirirente[$name] = 'null';
                    }
                }
            } else {
                $paramsadquirirente = array(
                    ':P_NRADQUIRENTE' => 'null'
                );
                $query = preg_replace('/'.':P_NRADQUIRENTE'.'/', $paramsadquirirente[':P_NRADQUIRENTE'], $query, 2);
            }
            if(is_array($P_NRPRODUTOADQ)){
                $paramsproduto = array(
                    ':P_NRPRODUTOADQ' => $P_NRPRODUTOADQ
                );
                foreach (array_keys($paramsproduto) as $index => $name) {
                    if(!empty($paramsproduto[$name])){
                        $query = $this->util->putArrayOnQuery($query, $name, $paramsproduto[$name]);
                        $paramsproduto[$name] = '';
                    }
                    else{
                        $paramsproduto[$name] = 'null';
                    }
                }
            } else {
                $paramsproduto = array(
                    ':P_NRPRODUTOADQ' => 'null'
                );
                 $query = preg_replace('/'.':P_NRPRODUTOADQ'.'/', $paramsproduto[':P_NRPRODUTOADQ'], $query, 2);
            }
            if(is_array($P_NRBANDEIRAVAN)){
                $paramsbandeira = array(
                    ':P_NRBANDEIRAVAN' => $P_NRBANDEIRAVAN
                );
                foreach (array_keys($paramsbandeira) as $index => $name) {
                    if(!empty($paramsbandeira[$name])){
                        $query = $this->util->putArrayOnQuery($query, $name, $paramsbandeira[$name]);
                        $paramsbandeira[$name] = '';
                    }
                    else{
                        $paramsbandeira[$name] = 'null';
                    }
                }
            } else {
                $paramsbandeira = array(
                    ':P_NRBANDEIRAVAN' => 'null'
                );
                 $query = preg_replace('/'.':P_NRBANDEIRAVAN'.'/', $paramsbandeira[':P_NRBANDEIRAVAN'], $query, 4);
            }
            $params = array(
                ':P_TNRESTABELEC'     => $P_TNRESTABELEC,
                ':P_TNRADQUIRENTE'     => $P_TNRADQUIRENTE,
                ':P_TNRPRODUTOADQ' => $P_TNRPRODUTOADQ,
                ':P_TNRBANDEIRAVAN'    => $P_TNRBANDEIRAVAN,
                ':P_TPVLR'         => $P_TPVLR,
                ':P_INTVEND'       => $P_INTVEND,
                ':DTVENDAINI'      => $DTVENDAINI,
                ':DTVENDAFIN'      => $DTVENDAFIN
            );
            $recebimentoBandeiras = $this->recebimentoBandeiraFactory->getReceiptFlagsPFiltered($params, $query);
            return $recebimentoBandeiras;
        }else {
        	$params = array(
				':P_NRESTABELEC'      => $P_NRESTABELEC,
				':P_TNRESTABELEC'     => $P_TNRESTABELEC,
				':P_NRADQUIRENTE'	   => $P_NRADQUIRENTE,
				':P_TNRADQUIRENTE'	   => $P_TNRADQUIRENTE,
				':P_NRPRODUTOADQ'  => $P_NRPRODUTOADQ,
				':P_TNRPRODUTOADQ' => $P_TNRPRODUTOADQ,
				':P_NRBANDEIRAVAN'     => $P_NRBANDEIRAVAN,
				':P_TNRBANDEIRAVAN'    => $P_TNRBANDEIRAVAN,
				':P_INTVEND'       => $P_INTVEND,
				':P_TPVLR' 	       => $P_TPVLR,
				':DTVENDAINI' 	   => $DTVENDAINI,
				':DTVENDAFIN' 	   => $DTVENDAFIN
			);
            $recebimentoBandeiras = $this->recebimentoBandeiraFactory->getReceiptFlagsP($params);         
            return $recebimentoBandeiras;
        }
	}

	public function getReceiptFlagsR($params){
        $P_NRESTABELEC      = $params[0]['value'];
        $P_NRADQUIRENTE      = $params[1]['value'];
        $P_NRPRODUTOADQ  = $params[2]['value'];
        $P_NRBANDEIRAVAN     = $params[3]['value'];
        for ($i=0; $i < sizeof($params); $i++) {
            if($params[$i]["columnName"] === 'intervalo'){
                $P_INTVEND = str_replace('%', '', $params[$i]['value']);
            }
        }
        if($P_INTVEND === 'M'){
            for ($i=0; $i < sizeof($params); $i++) {
                if($params[$i]["columnName"] === 'MESINI'){
                    $P_MESINI = str_replace('%', '', $params[$i]['value']);
                } if($params[$i]["columnName"] === 'MESFIN'){
                    $P_MESFIN = str_replace('%', '', $params[$i]['value']);
                }
            }
            $P_TPVLR         = str_replace('%', '', $params[7]['value']);
            $MEIORECE        = str_replace('%', '', $params[8]['value']);
            $P_TNRESTABELEC     = null;
            $P_TNRADQUIRENTE     = null;
            $P_TNRPRODUTOADQ = null;
            $P_TNRBANDEIRAVAN    = null;
            $DTVENDAINI     = '01/'.$P_MESINI;
            $lastDay        = date("t",mktime(0,0,0,substr($P_MESFIN, 0, -5),1,substr($P_MESFIN, -4)));
            $DTVENDAFIN     = $lastDay.'/'.$P_MESFIN;
            $explodeini     =  explode('/', $DTVENDAINI);
            $explodefin     =  explode('/', $DTVENDAFIN);
            $P_DTVENDAINI   = $explodeini[1].'/'.$explodeini[0].'/'.$explodeini[2]; 
            $P_DTVENDAFIN   = $explodefin[1].'/'.$explodefin[0].'/'.$explodefin[2];
            $P_VRDTVENDAINI = date_format(date_create($P_DTVENDAINI), "Ym");
            $P_VRDTVENDAFIN = date_format(date_create($P_DTVENDAFIN), "Ym");
            if ($P_VRDTVENDAFIN < $P_VRDTVENDAINI){
                throw new \Exception('MESERROR',1);
            }
            if ($P_VRDTVENDAFIN - $P_VRDTVENDAINI > 99){
                throw new \Exception('MESEXCEDEU',2);
            }
        } else{
            for ($i=0; $i < sizeof($params); $i++) {
                if($params[$i]["columnName"] === 'DTVENDA'){
                    $DTVENDAINI = str_replace('%', '', $params[$i]['value'][0]);
                    $DTVENDAFIN = str_replace('%', '', $params[$i]['value'][1]);
                }
            }
            $P_TPVLR         = str_replace('%', '', $params[6]['value']);
            $MEIORECE        = str_replace('%', '', $params[7]['value']);
            $P_TNRESTABELEC     = null;
            $P_TNRADQUIRENTE     = null;
            $P_TNRPRODUTOADQ = null;
            $P_TNRBANDEIRAVAN    = null;

            $explodeini     =  explode('/', $DTVENDAINI);
            $explodefin     =  explode('/', $DTVENDAFIN);
            $P_DTVENDAINI   = $explodeini[1].'/'.$explodeini[0].'/'.$explodeini[2]; 
            $P_DTVENDAFIN   = $explodefin[1].'/'.$explodefin[0].'/'.$explodefin[2];
            $P_VRDTVENDAINI = date_create($P_DTVENDAINI);
            $P_VRDTVENDAFIN = date_create($P_DTVENDAFIN);
            $P_VRDTVENDA    = $P_VRDTVENDAFIN->diff($P_VRDTVENDAINI);
            if($P_VRDTVENDA->d > 14){
                throw new \Exception('DIAERROR',1);
            }                
        }
        if($P_NRESTABELEC === 'Todas'){
            $P_TNRESTABELEC = 'T';
            $P_NRESTABELEC = null;
        }
        if($P_NRADQUIRENTE === 'Todas'){
            $P_TNRADQUIRENTE = 'T';
            $P_NRADQUIRENTE = null;
        }
        if($P_NRPRODUTOADQ === 'Todos'){
            $P_TNRPRODUTOADQ = 'T';
            $P_NRPRODUTOADQ = null;
        }
        if($P_NRBANDEIRAVAN === 'Todas'){
            $P_TNRBANDEIRAVAN = 'T';
            $P_NRBANDEIRAVAN = null;
        }
        if(is_array($P_NRESTABELEC) || is_array($P_NRADQUIRENTE) || is_array($P_NRPRODUTOADQ) || is_array($P_NRBANDEIRAVAN)){
            $query = "SELECT REPLACE(TO_CHAR(R.DTVENDA, 'MONTH-YYYY'), ' ', '') DATAVENDA, TO_NUMBER(TO_CHAR(R.DTVENDA, 'MMYYYY')) ORDEM, B.NMBANDEIRA, SUM(DECODE(:P_TPVLR, 'B', R.VRBRUTVENDA, R.VRLIQPGTO)) AS VRVENDA FROM RETFINANCADQ R, ADQUIRENTE A, PRODUTOADQ P, BANDEIRAVAN B WHERE R.NRADQUIRENTE = A.NRADQUIRENTE AND R.NRPRODUTOADQ = P.NRPRODUTOADQ AND R.NRBANDEIRAVAN = B.NRBANDEIRAVAN AND :P_INTVEND = 'M'AND R.DTVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN AND ((INSTR (:P_NRESTABELEC,     '|'||TO_CHAR(R.NRESTABELEC)||'|') > 0) OR ('T' = :P_TNRESTABELEC)) AND ((INSTR (:P_NRADQUIRENTE,     '|'||TO_CHAR(A.NRADQUIRENTE)||'|') > 0) OR ('T' = :P_TNRADQUIRENTE)) AND ((INSTR (:P_NRPRODUTOADQ, '|'||TO_CHAR(P.NRPRODUTOADQ)||'|') > 0) OR ('T' = :P_TNRPRODUTOADQ)) AND ((INSTR (:P_NRBANDEIRAVAN,    '|'||TO_CHAR(B.NRBANDEIRAVAN)||'|') > 0) OR ('T' = :P_TNRBANDEIRAVAN)) AND P.IDVISIVEL = 'S'AND B.IDVISIVEL = 'S'AND A.IDVISIVEL = 'S'GROUP BY REPLACE(TO_CHAR(R.DTVENDA, 'MONTH-YYYY'), ' ', ''), TO_NUMBER(TO_CHAR(R.DTVENDA, 'MMYYYY')), B.NMBANDEIRA UNION SELECT REPLACE(TO_CHAR(R.DTVENDA, 'DD/MM/YY'), ' ', '') DATAVENDA, TO_NUMBER(TO_CHAR(R.DTVENDA, 'MMYYYY')) ORDEM, B.NMBANDEIRA, SUM(DECODE(:P_TPVLR, 'B', R.VRBRUTVENDA, R.VRLIQPGTO)) AS VRVENDA FROM RETFINANCADQ R, ADQUIRENTE A, PRODUTOADQ P, BANDEIRAVAN B WHERE R.NRADQUIRENTE = A.NRADQUIRENTE AND R.NRPRODUTOADQ = P.NRPRODUTOADQ AND R.NRBANDEIRAVAN = B.NRBANDEIRAVAN AND :P_INTVEND = 'D'AND R.DTVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN AND ((INSTR (:P_NRESTABELEC,     '|'||TO_CHAR(R.NRESTABELEC)||'|') > 0) OR ('T' = :P_TNRESTABELEC)) AND ((INSTR (:P_NRADQUIRENTE,     '|'||TO_CHAR(A.NRADQUIRENTE)||'|') > 0) OR ('T' = :P_TNRADQUIRENTE)) AND ((INSTR (:P_NRPRODUTOADQ, '|'||TO_CHAR(P.NRPRODUTOADQ)||'|') > 0) OR ('T' = :P_TNRPRODUTOADQ)) AND ((INSTR (:P_NRBANDEIRAVAN,    '|'||TO_CHAR(B.NRBANDEIRAVAN)||'|') > 0) OR ('T' = :P_TNRBANDEIRAVAN)) AND P.IDVISIVEL = 'S'AND B.IDVISIVEL = 'S'AND A.IDVISIVEL = 'S'GROUP BY REPLACE(TO_CHAR(R.DTVENDA, 'DD/MM/YY'), ' ', ''), TO_NUMBER(TO_CHAR(R.DTVENDA, 'MMYYYY')), B.NMBANDEIRA ORDER BY 2,1,3"; 
            if(is_array($P_NRESTABELEC)){
                $paramsfilial = array(
                    ':P_NRESTABELEC' => $P_NRESTABELEC
                );
                foreach (array_keys($paramsfilial) as $index => $name) {
                    if(!empty($paramsfilial[$name])){
                        $query = $this->util->putArrayOnQuery($query, $name, $paramsfilial[$name]);
                        $paramsfilial[$name] = '';
                    }
                    else{
                        $paramsfilial[$name] = 'null';
                    }
                }
            } else {
                $paramsfilial = array(
                    ':P_NRESTABELEC' => 'null'
                );
                 $query = preg_replace('/'.':P_NRESTABELEC'.'/', $paramsfilial[':P_NRESTABELEC'], $query, 4);
            }
            if(is_array($P_NRADQUIRENTE)){
                $paramsadquirirente = array(
                    ':P_NRADQUIRENTE' => $P_NRADQUIRENTE
                );
                foreach (array_keys($paramsadquirirente) as $index => $name) {
                    if(!empty($paramsadquirirente[$name])){
                        $query = $this->util->putArrayOnQuery($query, $name, $paramsadquirirente[$name]);
                        $paramsadquirirente[$name] = '';
                    }
                    else{
                        $paramsadquirirente[$name] = 'null';
                    }
                }
            } else {
                $paramsadquirirente = array(
                    ':P_NRADQUIRENTE' => 'null'
                );
                $query = preg_replace('/'.':P_NRADQUIRENTE'.'/', $paramsadquirirente[':P_NRADQUIRENTE'], $query, 2);
            }
            if(is_array($P_NRPRODUTOADQ)){
                $paramsproduto = array(
                    ':P_NRPRODUTOADQ' => $P_NRPRODUTOADQ
                );
                foreach (array_keys($paramsproduto) as $index => $name) {
                    if(!empty($paramsproduto[$name])){
                        $query = $this->util->putArrayOnQuery($query, $name, $paramsproduto[$name]);
                        $paramsproduto[$name] = '';
                    }
                    else{
                        $paramsproduto[$name] = 'null';
                    }
                }
            } else {
                $paramsproduto = array(
                    ':P_NRPRODUTOADQ' => 'null'
                );
                 $query = preg_replace('/'.':P_NRPRODUTOADQ'.'/', $paramsproduto[':P_NRPRODUTOADQ'], $query, 2);
            }
            if(is_array($P_NRBANDEIRAVAN)){
                $paramsbandeira = array(
                    ':P_NRBANDEIRAVAN' => $P_NRBANDEIRAVAN
                );
                foreach (array_keys($paramsbandeira) as $index => $name) {
                    if(!empty($paramsbandeira[$name])){
                        $query = $this->util->putArrayOnQuery($query, $name, $paramsbandeira[$name]);
                        $paramsbandeira[$name] = '';
                    }
                    else{
                        $paramsbandeira[$name] = 'null';
                    }
                }
            } else {
                $paramsbandeira = array(
                    ':P_NRBANDEIRAVAN' => 'null'
                );
                 $query = preg_replace('/'.':P_NRBANDEIRAVAN'.'/', $paramsbandeira[':P_NRBANDEIRAVAN'], $query, 4);
            }
            $params = array(
                ':P_TNRESTABELEC'     => $P_TNRESTABELEC,
                ':P_TNRADQUIRENTE'     => $P_TNRADQUIRENTE,
                ':P_TNRPRODUTOADQ' => $P_TNRPRODUTOADQ,
                ':P_TNRBANDEIRAVAN'    => $P_TNRBANDEIRAVAN,
                ':P_TPVLR'         => $P_TPVLR,
                ':P_INTVEND'       => $P_INTVEND,
                ':DTVENDAINI'      => $DTVENDAINI,
                ':DTVENDAFIN'      => $DTVENDAFIN
            );
            $recebimentoBandeiras = $this->recebimentoBandeiraFactory->getReceiptFlagsRFiltered($params, $query);
            return $recebimentoBandeiras;
        }else {
        	$params = array(
				':P_NRESTABELEC'      => $P_NRESTABELEC,
				':P_TNRESTABELEC'     => $P_TNRESTABELEC,
				':P_NRADQUIRENTE'	   => $P_NRADQUIRENTE,
				':P_TNRADQUIRENTE'	   => $P_TNRADQUIRENTE,
				':P_NRPRODUTOADQ'  => $P_NRPRODUTOADQ,
				':P_TNRPRODUTOADQ' => $P_TNRPRODUTOADQ,
				':P_NRBANDEIRAVAN'     => $P_NRBANDEIRAVAN,
				':P_TNRBANDEIRAVAN'    => $P_TNRBANDEIRAVAN,
				':P_INTVEND'       => $P_INTVEND,
				':P_TPVLR' 	       => $P_TPVLR,
				':DTVENDAINI' 	   => $DTVENDAINI,
				':DTVENDAFIN' 	   => $DTVENDAFIN
			);
            $recebimentoBandeiras = $this->recebimentoBandeiraFactory->getReceiptFlagsR($params);
        	return $recebimentoBandeiras;
        }
	}

    public function getReceiptFlagsDetails($params){
        $P_NRADQUIRENTE   = $params[0]['value'];
        $P_NRPRODUTOADQ   = $params[1]['value'];
        $P_NRBANDEIRAVAN  = $params[2]['value'];
        $P_NRESTABELEC    = $params[3]['value'];
        $DTVENDAINI       = $params[4]['value'];
        $DTVENDAFIN       = $params[5]['value'];
        $MEIORECE         = $params[6]['value'];
        $P_INTVEND        = $params[7]['value'];
        $P_TNRESTABELEC   = null;
        $P_TNRADQUIRENTE  = null;
        $P_TNRPRODUTOADQ  = null;
        $P_TNRBANDEIRAVAN = null;

        if($P_INTVEND === 'M'){
            $DTVENDAINI     = '01/'.$DTVENDAINI;
            $lastDay        = date("t",mktime(0,0,0,substr($DTVENDAFIN, 0, -5),1,substr($DTVENDAFIN, -4)));
            $DTVENDAFIN     = $lastDay.'/'.$DTVENDAFIN;
        }

        if($P_NRESTABELEC === 'Todas'){
            $P_TNRESTABELEC = 'T';
            $P_NRESTABELEC = null;
        }
        if($P_NRADQUIRENTE === 'Todas'){
            $P_TNRADQUIRENTE = 'T';
            $P_NRADQUIRENTE = null;
        }
        if($P_NRPRODUTOADQ === 'Todos'){
            $P_TNRPRODUTOADQ = 'T';
            $P_NRPRODUTOADQ = null;
        }
        if($P_NRBANDEIRAVAN === 'Todas'){
            $P_TNRBANDEIRAVAN = 'T';
            $P_NRBANDEIRAVAN = null;
        }
        if(is_array($P_NRESTABELEC) || is_array($P_NRADQUIRENTE) || is_array($P_NRPRODUTOADQ) || is_array($P_NRBANDEIRAVAN)){
            $query = "SELECT B.NMBANDEIRA PRIMARY, '' PARENT, NULL DTORDENACAO, B.NMBANDEIRA, NULL DTVENDA, '' CDNSU,  SUM(R.VRBRUTVENDA) VRBRUTO, SUM(R.VRLIQVENDA) VRLIQUIDO, NULL NRRETVENDAADQ, NULL NRBANDEIRAVAN, NULL NRADQUIRENTE, '' NMESTABELEC, '' NMADQUIRENTE, NULL NRPRODUTOADQ, '' NMPRODUTOADQ FROM RETVENDAADQ R, ADQUIRENTE A, PRODUTOADQ P, BANDEIRAVAN B, CONSMOVCAIXA C, ESTABELECIMENTO E WHERE R.NRADQUIRENTE = A.NRADQUIRENTE AND R.NRPRODUTOADQ = P.NRPRODUTOADQ AND R.NRCONCLANC = C.NRCONCLANC AND :MEIORECE = 'P' AND R.NRBANDEIRAVAN = B.NRBANDEIRAVAN AND R.NRESTABELEC = E.NRESTABELEC AND R.DTVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN AND ((INSTR (:P_NRESTABELEC,     '|'||TO_CHAR(R.NRESTABELEC)||'|') > 0) OR ('T' = :P_TNRESTABELEC)) AND ((INSTR (:P_NRADQUIRENTE,     '|'||TO_CHAR(A.NRADQUIRENTE)||'|') > 0) OR ('T' = :P_TNRADQUIRENTE)) AND ((INSTR (:P_NRPRODUTOADQ, '|'||TO_CHAR(P.NRPRODUTOADQ)||'|') > 0) OR ('T' = :P_TNRPRODUTOADQ)) AND ((INSTR (:P_NRBANDEIRAVAN,    '|'||TO_CHAR(B.NRBANDEIRAVAN)||'|') > 0) OR ('T' = :P_TNRBANDEIRAVAN)) AND P.IDVISIVEL = 'S' AND A.IDVISIVEL = 'S' GROUP BY B.NMBANDEIRA UNION SELECT B.NMBANDEIRA || ' - ' || R.NRRETVENDAADQ PRIMARY, B.NMBANDEIRA PARENT, R.DTVENDA DTORDENACAO, '' NMBANDEIRA, TO_CHAR(R.DTVENDA, 'DD/MM/YYYY') DTVENDA, R.CDNSU, R.VRBRUTVENDA VRBRUTO, R.VRLIQVENDA VRLIQUIDO, R.NRRETVENDAADQ, B.NRBANDEIRAVAN, R.NRADQUIRENTE, E.NMESTABELEC, A.NMADQUIRENTE, R.NRPRODUTOADQ, P.NMPRODUTOADQ FROM RETVENDAADQ R, ADQUIRENTE A, PRODUTOADQ P, BANDEIRAVAN B, CONSMOVCAIXA C, ESTABELECIMENTO E WHERE R.NRADQUIRENTE = A.NRADQUIRENTE AND R.NRPRODUTOADQ = P.NRPRODUTOADQ AND R.NRCONCLANC = C.NRCONCLANC AND :MEIORECE = 'P' AND R.NRBANDEIRAVAN = B.NRBANDEIRAVAN AND R.NRESTABELEC = E.NRESTABELEC AND R.DTVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN AND ((INSTR (:P_NRESTABELEC,     '|'||TO_CHAR(R.NRESTABELEC)||'|') > 0) OR ('T' = :P_TNRESTABELEC)) AND ((INSTR (:P_NRADQUIRENTE,     '|'||TO_CHAR(A.NRADQUIRENTE)||'|') > 0) OR ('T' = :P_TNRADQUIRENTE)) AND ((INSTR (:P_NRPRODUTOADQ, '|'||TO_CHAR(P.NRPRODUTOADQ)||'|') > 0) OR ('T' = :P_TNRPRODUTOADQ)) AND ((INSTR (:P_NRBANDEIRAVAN,    '|'||TO_CHAR(B.NRBANDEIRAVAN)||'|') > 0) OR ('T' = :P_TNRBANDEIRAVAN)) AND P.IDVISIVEL = 'S' AND A.IDVISIVEL = 'S' UNION ALL SELECT B.NMBANDEIRA PRIMARY, '' PARENT, NULL DTORDENACAO, B.NMBANDEIRA, NULL DTVENDA, '' CDNSU, SUM(R.VRBRUTVENDA) VRBRUTO, SUM(R.VRLIQPGTO) VRLIQUIDO, NULL NRRETFINANCADQ, NULL NRBANDEIRAVAN, NULL NRADQUIRENTE, '' NMESTABELEC, '' NMADQUIRENTE, NULL NRPRODUTOADQ, '' NMPRODUTOADQ FROM RETFINANCADQ R, ADQUIRENTE A, PRODUTOADQ P, BANDEIRAVAN B, ESTABELECIMENTO E WHERE R.NRADQUIRENTE = A.NRADQUIRENTE AND R.NRPRODUTOADQ = P.NRPRODUTOADQ AND :MEIORECE = 'R' AND R.NRBANDEIRAVAN = B.NRBANDEIRAVAN AND R.NRESTABELEC = E.NRESTABELEC AND R.NRPRODUTOADQ = P.NRPRODUTOADQ AND R.DTVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN AND ((INSTR (:P_NRESTABELEC,     '|'||TO_CHAR(R.NRESTABELEC)||'|') > 0) OR ('T' = :P_TNRESTABELEC)) AND ((INSTR (:P_NRADQUIRENTE,     '|'||TO_CHAR(A.NRADQUIRENTE)||'|') > 0) OR ('T' = :P_TNRADQUIRENTE)) AND ((INSTR (:P_NRPRODUTOADQ, '|'||TO_CHAR(P.NRPRODUTOADQ)||'|') > 0) OR ('T' = :P_TNRPRODUTOADQ)) AND ((INSTR (:P_NRBANDEIRAVAN,    '|'||TO_CHAR(B.NRBANDEIRAVAN)||'|') > 0) OR ('T' = :P_TNRBANDEIRAVAN)) AND P.IDVISIVEL = 'S' AND B.IDVISIVEL = 'S' AND A.IDVISIVEL = 'S' GROUP BY B.NMBANDEIRA UNION SELECT B.NMBANDEIRA || ' - ' || R.NRRETFINANCADQ PRIMARY, B.NMBANDEIRA PARENT, R.DTVENDA DTORDENACAO, '' NMBANDEIRA, TO_CHAR(R.DTVENDA, 'DD/MM/YYYY') DTVENDA, R.CDNSU, R.VRBRUTVENDA VRBRUTO, R.VRLIQPGTO VRLIQUIDO, R.NRRETFINANCADQ, B.NRBANDEIRAVAN, R.NRADQUIRENTE, E.NMESTABELEC, A.NMADQUIRENTE, R.NRPRODUTOADQ, P.NMPRODUTOADQ FROM RETFINANCADQ R, ADQUIRENTE A, PRODUTOADQ P, BANDEIRAVAN B, ESTABELECIMENTO E WHERE R.NRADQUIRENTE = A.NRADQUIRENTE AND R.NRPRODUTOADQ = P.NRPRODUTOADQ AND :MEIORECE = 'R' AND R.NRBANDEIRAVAN = B.NRBANDEIRAVAN AND R.NRESTABELEC = E.NRESTABELEC AND R.NRPRODUTOADQ = P.NRPRODUTOADQ AND R.DTVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN AND ((INSTR (:P_NRESTABELEC,     '|'||TO_CHAR(R.NRESTABELEC)||'|') > 0) OR ('T' = :P_TNRESTABELEC)) AND ((INSTR (:P_NRADQUIRENTE,     '|'||TO_CHAR(A.NRADQUIRENTE)||'|') > 0) OR ('T' = :P_TNRADQUIRENTE)) AND ((INSTR (:P_NRPRODUTOADQ, '|'||TO_CHAR(P.NRPRODUTOADQ)||'|') > 0) OR ('T' = :P_TNRPRODUTOADQ)) AND ((INSTR (:P_NRBANDEIRAVAN,    '|'||TO_CHAR(B.NRBANDEIRAVAN)||'|') > 0) OR ('T' = :P_TNRBANDEIRAVAN)) AND P.IDVISIVEL = 'S' AND B.IDVISIVEL = 'S' AND A.IDVISIVEL = 'S' ORDER BY DTORDENACAO, PRIMARY"; 
            if(is_array($P_NRESTABELEC)){
                $paramsfilial = array(
                    ':P_NRESTABELEC' => $P_NRESTABELEC
                );
                foreach (array_keys($paramsfilial) as $index => $name) {
                    if(!empty($paramsfilial[$name])){
                        $query = $this->util->putArrayOnQuery($query, $name, $paramsfilial[$name]);
                        $paramsfilial[$name] = '';
                    }
                    else{
                        $paramsfilial[$name] = 'null';
                    }
                }
            } else {
                $paramsfilial = array(
                    ':P_NRESTABELEC' => 'null'
                );
                 $query = preg_replace('/'.':P_NRESTABELEC'.'/', $paramsfilial[':P_NRESTABELEC'], $query, 4);
            }
            if(is_array($P_NRADQUIRENTE)){
                $paramsadquirirente = array(
                    ':P_NRADQUIRENTE' => $P_NRADQUIRENTE
                );
                foreach (array_keys($paramsadquirirente) as $index => $name) {
                    if(!empty($paramsadquirirente[$name])){
                        $query = $this->util->putArrayOnQuery($query, $name, $paramsadquirirente[$name]);
                        $paramsadquirirente[$name] = '';
                    }
                    else{
                        $paramsadquirirente[$name] = 'null';
                    }
                }
            } else {
                $paramsadquirirente = array(
                    ':P_NRADQUIRENTE' => 'null'
                );
                $query = preg_replace('/'.':P_NRADQUIRENTE'.'/', $paramsadquirirente[':P_NRADQUIRENTE'], $query, 4);
            }
            if(is_array($P_NRPRODUTOADQ)){
                $paramsproduto = array(
                    ':P_NRPRODUTOADQ' => $P_NRPRODUTOADQ
                );
                foreach (array_keys($paramsproduto) as $index => $name) {
                    if(!empty($paramsproduto[$name])){
                        $query = $this->util->putArrayOnQuery($query, $name, $paramsproduto[$name]);
                        $paramsproduto[$name] = '';
                    }
                    else{
                        $paramsproduto[$name] = 'null';
                    }
                }
            } else {
                $paramsproduto = array(
                    ':P_NRPRODUTOADQ' => 'null'
                );
                 $query = preg_replace('/'.':P_NRPRODUTOADQ'.'/', $paramsproduto[':P_NRPRODUTOADQ'], $query, 4);
            }
            if(is_array($P_NRBANDEIRAVAN)){
                $paramsbandeira = array(
                    ':P_NRBANDEIRAVAN' => $P_NRBANDEIRAVAN
                );
                foreach (array_keys($paramsbandeira) as $index => $name) {
                    if(!empty($paramsbandeira[$name])){
                        $query = $this->util->putArrayOnQuery($query, $name, $paramsbandeira[$name]);
                        $paramsbandeira[$name] = '';
                    }
                    else{
                        $paramsbandeira[$name] = 'null';
                    }
                }
            } else {
                $paramsbandeira = array(
                    ':P_NRBANDEIRAVAN' => 'null'
                );
                 $query = preg_replace('/'.':P_NRBANDEIRAVAN'.'/', $paramsbandeira[':P_NRBANDEIRAVAN'], $query, 4);
            }
            $params = array(
                ':P_TNRESTABELEC'   => $P_TNRESTABELEC,
                ':P_TNRADQUIRENTE'  => $P_TNRADQUIRENTE,
                ':P_TNRPRODUTOADQ'  => $P_TNRPRODUTOADQ,
                ':P_TNRBANDEIRAVAN' => $P_TNRBANDEIRAVAN,
                ':DTVENDAINI'       => $DTVENDAINI,
                ':DTVENDAFIN'       => $DTVENDAFIN,
                ':MEIORECE'         => $MEIORECE
            );
            $recebimentoBandeiras = $this->recebimentoBandeiraFactory->getReceiptFlagsDetailsFiltered($params, $query);
            return $recebimentoBandeiras;
        }else {
            $params = array(
                ':P_NRESTABELEC'    => $P_NRESTABELEC,
                ':P_TNRESTABELEC'   => $P_TNRESTABELEC,
                ':P_NRADQUIRENTE'   => $P_NRADQUIRENTE,
                ':P_TNRADQUIRENTE'  => $P_TNRADQUIRENTE,
                ':P_NRPRODUTOADQ'   => $P_NRPRODUTOADQ,
                ':P_TNRPRODUTOADQ'  => $P_TNRPRODUTOADQ,
                ':P_NRBANDEIRAVAN'  => $P_NRBANDEIRAVAN,
                ':P_TNRBANDEIRAVAN' => $P_TNRBANDEIRAVAN,
                ':DTVENDAINI'       => $DTVENDAINI,
                ':DTVENDAFIN'       => $DTVENDAFIN,
                ':MEIORECE'         => $MEIORECE
            );
            $recebimentoBandeiras = $this->recebimentoBandeiraFactory->getReceiptFlagsDetails($params);
            return $recebimentoBandeiras;
        }
    }
}